<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>celGameServerManager Class Reference (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">celGameServerManager Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="celGameServerManager" -->
<p>This is an interface you should implement in order to manage the events from the server.  
 <a href="classcelGameServerManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="network_8h_source.html">physicallayer/network.h</a>&gt;</code></p>

<p><a href="classcelGameServerManager-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameServerManager.html#a7099380d2f41b043f3ae2c513cc1a0b2">AuthorizePlayer</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> &amp;reason)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A player is asking to join the game.  <a href="#a7099380d2f41b043f3ae2c513cc1a0b2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameServerManager.html#a5bbf3b77ea631e94e5f8c1fccb97e4db">HandleClientEvent</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player, celClientEventType event_type, <a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> event_time, <a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *event_data)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A client event has been catched.  <a href="#a5bbf3b77ea631e94e5f8c1fccb97e4db"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameServerManager.html#a1bd1f5db329bf4f59b10ee3ef6835491">PersistenceProblem</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player, <a class="el" href="structiCelEntity.html">iCelEntity</a> *entity, <a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a> *pc, celPersistenceResult persist_code)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">An entity is controlled by a player and a problem was encountered while updating the data of this entity.  <a href="#a1bd1f5db329bf4f59b10ee3ef6835491"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameServerManager.html#ac631853c4262d0e20da841e5a9dc832c">PlayerNetworkStateChanged</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *player, celPlayerNetworkState new_state, celPlayerNetworkState previous_state)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The state of the network connection to the player has changed.  <a href="#ac631853c4262d0e20da841e5a9dc832c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameServerManager.html#a1b6f49c05e21921c0b669c1c4f1fdf08">ServerEnd</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The game is finished and the server will be closed.  <a href="#a1b6f49c05e21921c0b669c1c4f1fdf08"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classcelGameServerManager.html#a67efb888c26193128c48a1887b5e45ee">ValidatePlayerUpdate</a> (<a class="el" href="classcelPlayer.html">celPlayer</a> *previous_player_data)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Check if the new data of a player are valid.  <a href="#a67efb888c26193128c48a1887b5e45ee"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>This is an interface you should implement in order to manage the events from the server. </p>
<p>You can use it to:</p>
<ul>
<li>authorize players to join the game, check the validity of the data of the players.</li>
<li>listen for changes in the state of the network connections to the clients.</li>
<li>catch the client events.</li>
<li>handle the detection of cheats.</li>
<li>close the game. </li>
</ul>

<p>Definition at line <a class="el" href="network_8h_source.html#l00595">595</a> of file <a class="el" href="network_8h_source.html">network.h</a>.</p>
</div><hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a7099380d2f41b043f3ae2c513cc1a0b2"></a><!-- doxytag: member="celGameServerManager::AuthorizePlayer" ref="a7099380d2f41b043f3ae2c513cc1a0b2" args="(celPlayer *player, csString &amp;reason)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classcelGameServerManager.html#a7099380d2f41b043f3ae2c513cc1a0b2">celGameServerManager::AuthorizePlayer</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> &amp;&#160;</td>
          <td class="paramname"><em>reason</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A player is asking to join the game. </p>
<p>Return true if the new player is accepted, false otherwise (for example, because the player has been banned). A text explaining the reason of a negative answer can be specified. </p>

</div>
</div>
<a class="anchor" id="a5bbf3b77ea631e94e5f8c1fccb97e4db"></a><!-- doxytag: member="celGameServerManager::HandleClientEvent" ref="a5bbf3b77ea631e94e5f8c1fccb97e4db" args="(celPlayer *player, celClientEventType event_type, csTicks event_time, iCelDataBuffer *event_data)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameServerManager.html#a5bbf3b77ea631e94e5f8c1fccb97e4db">celGameServerManager::HandleClientEvent</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">celClientEventType&#160;</td>
          <td class="paramname"><em>event_type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="elRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a>&#160;</td>
          <td class="paramname"><em>event_time</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelDataBuffer.html">iCelDataBuffer</a> *&#160;</td>
          <td class="paramname"><em>event_data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>A client event has been catched. </p>

</div>
</div>
<a class="anchor" id="a1bd1f5db329bf4f59b10ee3ef6835491"></a><!-- doxytag: member="celGameServerManager::PersistenceProblem" ref="a1bd1f5db329bf4f59b10ee3ef6835491" args="(celPlayer *player, iCelEntity *entity, iCelPropertyClass *pc, celPersistenceResult persist_code)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameServerManager.html#a1bd1f5db329bf4f59b10ee3ef6835491">celGameServerManager::PersistenceProblem</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelEntity.html">iCelEntity</a> *&#160;</td>
          <td class="paramname"><em>entity</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structiCelPropertyClass.html">iCelPropertyClass</a> *&#160;</td>
          <td class="paramname"><em>pc</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">celPersistenceResult&#160;</td>
          <td class="paramname"><em>persist_code</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>An entity is controlled by a player and a problem was encountered while updating the data of this entity. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">player</td><td>The player controlling the entity. </td></tr>
    <tr><td class="paramname">entity</td><td>The entity controlled by the player. </td></tr>
    <tr><td class="paramname">pc</td><td>The property class updated while the problem was encountered. </td></tr>
    <tr><td class="paramname">persist_code</td><td>The code of the problem. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ac631853c4262d0e20da841e5a9dc832c"></a><!-- doxytag: member="celGameServerManager::PlayerNetworkStateChanged" ref="ac631853c4262d0e20da841e5a9dc832c" args="(celPlayer *player, celPlayerNetworkState new_state, celPlayerNetworkState previous_state)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameServerManager.html#ac631853c4262d0e20da841e5a9dc832c">celGameServerManager::PlayerNetworkStateChanged</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>player</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">celPlayerNetworkState&#160;</td>
          <td class="paramname"><em>new_state</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">celPlayerNetworkState&#160;</td>
          <td class="paramname"><em>previous_state</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The state of the network connection to the player has changed. </p>

</div>
</div>
<a class="anchor" id="a1b6f49c05e21921c0b669c1c4f1fdf08"></a><!-- doxytag: member="celGameServerManager::ServerEnd" ref="a1b6f49c05e21921c0b669c1c4f1fdf08" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classcelGameServerManager.html#a1b6f49c05e21921c0b669c1c4f1fdf08">celGameServerManager::ServerEnd</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The game is finished and the server will be closed. </p>
<p>You should delete here all entities and the physical layer. </p>

</div>
</div>
<a class="anchor" id="a67efb888c26193128c48a1887b5e45ee"></a><!-- doxytag: member="celGameServerManager::ValidatePlayerUpdate" ref="a67efb888c26193128c48a1887b5e45ee" args="(celPlayer *previous_player_data)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classcelPlayer.html">celPlayer</a>* <a class="el" href="classcelGameServerManager.html#a67efb888c26193128c48a1887b5e45ee">celGameServerManager::ValidatePlayerUpdate</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classcelPlayer.html">celPlayer</a> *&#160;</td>
          <td class="paramname"><em>previous_player_data</em></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Check if the new data of a player are valid. </p>
<p>It happens when <a class="el" href="structiCelGameClient.html#a89bc1a1269e364572b58d434b90a2ecd" title="Update the data of the current player.">iCelGameClient::UpdatePlayer</a> has been called on the client side. </p>
<dl class="return"><dt><b>Returns:</b></dt><dd>the validated data of the player. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>physicallayer/<a class="el" href="network_8h_source.html">network.h</a></li>
</ul>
</div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
